package com.jasamedika.medifirst2000.vo;

import java.io.Serializable;
import javax.persistence.*;
import java.util.Date;
import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import com.jasamedika.medifirst2000.helper.Caption;

/**
 *  class PersenHargaJualProduk
 * 
 * @author Generator
 */
//@Entity
//@Table(name = "PersenHargaJualProduk_M")
public class PersenHargaJualProdukVO extends BaseMasterVO {
	@Caption(value="Jenis Harga Netto")
	private Byte jenisHargaNetto;

	public void setJenisHargaNetto(Byte jenisHargaNetto) {
		this.jenisHargaNetto = jenisHargaNetto;
	}

	@Column(name = "JenisHargaNetto", nullable = false )
	public Byte getJenisHargaNetto(){
		return this.jenisHargaNetto;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectAsalProdukFk")
	@NotNull(message="Object Asal ProdukVO Harus Diisi")
	@Caption(value="Object Asal Produk")
	private AsalProdukVO asalProduk;

	public void setAsalProduk(AsalProdukVO asalProduk) {
		this.asalProduk = asalProduk;
	}

	@Column(name = "KdAsalProduk", nullable = false )
	public AsalProdukVO getAsalProduk(){
		return this.asalProduk;
	}

	@Column(name = "ObjectAsalProdukFk", insertable=false,updatable=false)
	private Integer asalProdukId;

	@ManyToOne
	@JoinColumn(name = "ObjectJenisTransaksiFk")
	@NotNull(message="Object Jenis Transaksi Harus Diisi")
	@Caption(value="Object Jenis Transaksi")
	private JenisTransaksiVO jenisTransaksi;

	public void setJenisTransaksi(JenisTransaksiVO jenisTransaksi) {
		this.jenisTransaksi = jenisTransaksi;
	}

	@Column(name = "KdJenisTransaksi", nullable = false )
	public JenisTransaksiVO getJenisTransaksi(){
		return this.jenisTransaksi;
	}

	@Column(name = "ObjectJenisTransaksiFk", insertable=false,updatable=false)
	private Integer jenisTransaksiId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasFk")
	@NotNull(message="Object KelasVO Harus Diisi")
	@Caption(value="Object Kelas")
	private DetailKamarVO kelas;

	public void setKelas(DetailKamarVO kelas) {
		this.kelas = kelas;
	}

	@Column(name = "KdKelas", nullable = false , length = 2)
	public DetailKamarVO getKelas(){
		return this.kelas;
	}

	@Column(name = "ObjectKelasFk", insertable=false,updatable=false)
	private Integer kelasId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasPembandingFk")
	@Caption(value="Object KelasVO Pembanding")
	private DetailKamarVO kelasPembanding;

	public void setKelasPembanding(DetailKamarVO kelasPembanding) {
		this.kelasPembanding = kelasPembanding;
	}

	@Column(name = "KdKelasPembanding", nullable = true , length = 2)
	public DetailKamarVO getKelasPembanding(){
		return this.kelasPembanding;
	}

	@Column(name = "ObjectKelasPembandingFk", insertable=false,updatable=false)
	private Integer kelasPembandingId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasTarifFk")
	@NotNull(message="Object KelasVO Tarif Harus Diisi")
	@Caption(value="Object KelasVO Tarif")
	private DetailKamarVO kelasTarif;

	public void setKelasTarif(DetailKamarVO kelasTarif) {
		this.kelasTarif = kelasTarif;
	}

	@Column(name = "KdKelasTarif", nullable = false , length = 2)
	public DetailKamarVO getKelasTarif(){
		return this.kelasTarif;
	}

	@Column(name = "ObjectKelasTarifFk", insertable=false,updatable=false)
	private Integer kelasTarifId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokPasienFk")
	@NotNull(message="Object Kelompok PasienVO Harus Diisi")
	@Caption(value="Object Kelompok Pasien")
	private KelompokPasienVO kelompokPasien;

	public void setKelompokPasien(KelompokPasienVO kelompokPasien) {
		this.kelompokPasien = kelompokPasien;
	}

	@Column(name = "KdKelompokPasien", nullable = false )
	public KelompokPasienVO getKelompokPasien(){
		return this.kelompokPasien;
	}

	@Column(name = "ObjectKelompokPasienFk", insertable=false,updatable=false)
	private Integer kelompokPasienId;

	@Caption(value="Kode Penjamin Pasien")
	private short kdPenjaminPasien;

	public void setKdPenjaminPasien(short kdPenjaminPasien) {
		this.kdPenjaminPasien = kdPenjaminPasien;
	}

	@Column(name = "KdPenjaminPasien", nullable = false )
	public short getKdPenjaminPasien(){
		return this.kdPenjaminPasien;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectRangeFk")
	@NotNull(message="Object RangeVO Harus Diisi")
	@Caption(value="Object Range")
	private RangeVO range;

	public void setRange(RangeVO range) {
		this.range = range;
	}

	@Column(name = "KdRange", nullable = false )
	public RangeVO getRange(){
		return this.range;
	}

	@Column(name = "ObjectRangeFk", insertable=false,updatable=false)
	private Integer rangeId;

	@Caption(value="Persen Up Harga Satuan")
	private Double persenUpHargaSatuan;

	public void setPersenUpHargaSatuan(Double persenUpHargaSatuan) {
		this.persenUpHargaSatuan = persenUpHargaSatuan;
	}

	@Column(name = "PersenUpHargaSatuan", nullable = false )
	public Double getPersenUpHargaSatuan(){
		return this.persenUpHargaSatuan;
	}

	@Caption(value="Tanggal Berlaku Akhir")
	private Date tglBerlakuAkhir;

	public void setTglBerlakuAkhir(Date tglBerlakuAkhir) {
		this.tglBerlakuAkhir = tglBerlakuAkhir;
	}

	@Column(name = "TglBerlakuAkhir", nullable = true )
	public Date getTglBerlakuAkhir(){
		return this.tglBerlakuAkhir;
	}

	@Caption(value="Tanggal Berlaku Awal")
	private Date tglBerlakuAwal;

	public void setTglBerlakuAwal(Date tglBerlakuAwal) {
		this.tglBerlakuAwal = tglBerlakuAwal;
	}

	@Column(name = "TglBerlakuAwal", nullable = false )
	public Date getTglBerlakuAwal(){
		return this.tglBerlakuAwal;
	}


}

